# Features

The DataStax C# Driver for Apache Cassandra and DataStax Enterprise is a feature-rich and highly tunable C# client library for Apache Cassandra (2.0+) and DataStax Enterprise (4.8+) using Cassandra's binary protocol and Cassandra Query Language v3.

## Usage

- [Address resolution](address-resolution)
- [Authentication](auth)
- [Automatic failover](automatic-failover)
- [Components](components)
  - [Core](components/core)
  - [Linq](components/linq)
  - [Mapper](components/mapper)
  - [ADO.NET](components/adonet)
- [Connecting to DataStax Astra](cloud)
- [Connection heartbeat](connection-heartbeat)
- [Connection pooling](connection-pooling)
- [CQL data types to C# types](datatypes)
- [Execution Profiles](execution-profiles)
- [Cluster and schema metadata](metadata)
- [Geospatial types support](geotypes)
- [Graph support](graph-support)
- [Metrics](metrics)
  - [App.Metrics Provider](metrics/app-metrics)
  - [List of metrics](metrics/metrics-list)
- [Native protocol](native-protocol)
- [Parametrized queries](parametrized-queries)
- [Query timestamps](query-timestamps)
- [Query warnings](query-warnings)
- [Result paging](paging)
- [Routing queries](routing-queries)
- [Speculative executions](speculative-retries)
- [Tuning policies](tuning-policies)
- [TLS/SSL](tls)
- [User-defined functions and aggregates](udfs)
- [User-defined types](udts)
